洛谷P2320$\lceil$HNOI2006$\rfloor$题解

神奇的解法!

洛谷P2320鬼谷子的钱袋

题目描述

鬼谷子非常聪明,正因为这样,他非常繁忙,经常有各诸侯车的特派员前来向他咨询时政。

有一天,他在咸阳游历的时候,朋友告诉他在咸阳最大的拍卖行(聚宝商行)将要举行一场拍卖会,其中有一件宝物引起了他极大的兴趣,那就是无字天书。

但是,他的行程安排得很满,他已经买好了去邯郸的长途马车票,不巧的是出发时间是在拍卖会快要结束的时候。于是,他决定事先做好准备,将自己的金币数好并用一个个的小钱袋装好,以便在他现有金币的支付能力下,任何数目的金币他都能用这些封闭好的小钱的组合来付账。

鬼谷子也是一个非常节俭的人,他想方设法使自己在满足上述要求的前提下,所用的钱袋数最少,并且不有两个钱袋装有相同的大于1的金币数。假设他有m个金币,你能猜到他会用多少个钱袋,并且每个钱袋装多少个金币吗?

输入输出格式

输入格式

包含一个整数,表示鬼谷子现有的总的金币数目$m$。其中,$1 \leq m \leq 10^9$。

输出格式

两行,第一行一个整数h,表示所用钱袋个数

第二行表示每个钱袋所装的金币个数,由小到大输出,空格隔开

INPUT & OUTPUT’s examples

Input’s eg #1

1
3

Output’s eg #1

1
2
2
1 2

分析

输入数据这是要炸了的节奏啊。。。。

在$10^9$的数据范围内,我们显然只能考虑$O(\log n)$的二分了。

我们来举一个栗子,就拿样例吧

显然样例不行,我们拿$10$这个数当例子。

我们把$10$二分,可以得到两个$5$,然后对于一个$5$继续二分,分成$3$和$2$,然后再对$2$二分,得到两个$1$。

所以对于输入数据为$10$的答案就是$1,1,3,5$。

也就是说,我们对于一个$N$,进行连续的二分,最终直到$N=0$为止。

这里我们开一个$\text{可随机查询栈}$(雾,来维护二分过程,最后直接倒序输出这个栈里的内容即可。

代码

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
/* Headers */
#include<cstdio>
#include<cstring>
#include<cmath>
#include<cctype>
using namespace std;
using namespace std;
namespace FastIO{
const int BUFSIZE=1<<20;
char ibuf[BUFSIZE],*is=ibuf,*its=ibuf;
char obuf[BUFSIZE],*os=obuf,*ot=obuf+BUFSIZE;
inline char getch(){
if(is==its)
its=(is=ibuf)+fread(ibuf,1,BUFSIZE,stdin);
return (is==its)?EOF:*is++;
}
inline int getint(){
int res=0,neg=0,ch=getch();
while(!(isdigit(ch)||ch=='-')&&ch!=EOF)
ch=getch();
if(ch=='-'){
neg=1;ch=getch();
}
while(isdigit(ch)){
res=(res<<3)+(res<<1)+(ch-'0');
ch=getch();
}
return neg?-res:res;
}
inline void flush(){
fwrite(obuf,1,os-obuf,stdout);
os=obuf;
}
inline void putch(char ch){
*os++=ch;
if(os==ot) flush();
}
inline void putint(int res){
static char q[10];
if(res==0) putch('0');
else if(res<0){
putch('-');
res=-res;
}
int top=0;
while(res){
q[top++]=res%10+'0';
res/=10;
}
while(top--) putch(q[top]);
}
}
using namespace FastIO;
/* definitions */
const int MAXN = 2e6+7;
long long n;
struct Stack{
int stack[MAXN];
int cnt;
};
Stack k;
/* functions */
inline void push(int x){
k.stack[++k.cnt]=x;
}
inline void pop(){
k.cnt--;
}
inline int size(){
return k.cnt;
}
inline void work(){
scanf("%lld",&n);
while(n){
push((n+1)/2);
n/=2;
}
printf("%d\n",size());
}
int main(int argc,char *argv[]){
work();
for(int i=size();i>=1;i--)printf("%d ",k.stack[i]);
puts("");
return 0;
}

THE END